package com.jeeplus.modules.sg.util;

import com.jeeplus.common.utils.excel.ImportExcel;
import com.jeeplus.modules.sg.entity.JkxlData;
import org.apache.poi.openxml4j.exceptions.InvalidFormatException;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class JkxlExcel {
    public static List<JkxlData> getData(MultipartFile  file,Double[] rate) throws IOException, InvalidFormatException {
        ImportExcel importExcel = new ImportExcel(file,1,3);
        List<JkxlData> list = new ArrayList<>();
        int lastRow = importExcel.getLastDataRowNum();
        int[] row = new int[6];
        for(int i=0;i<lastRow;i++){
            String type =  importExcel.getValue(i+1,2);
            if(type.equals("1 基础工程")){
                row[0] = i+1;
            }
            if(type.equals("2 杆塔工程")){
                row[1] = i+1;
            }
            if(type.equals("3 接地工程")){
                row[2] = i+1;
            }
            if(type.equals("4 架线工程")){
                row[3] = i+1;
            }
            if(type.equals("5 附件安装工程")){
                row[4] = i+1;
            }
            if(type.equals("6 辅助工程")){
                row[5] = i+1;
            }
        }
        for(int i=0;i<6;i++){
            JkxlData jkxlData = new JkxlData();
            Double originalRgCost = importExcel.getDouble(row[i],13);
            Double rgCost = originalRgCost/(1+rate[0]);
            Double originalCbrCost = importExcel.getDouble(row[i],14);
            Double cbrCost = originalCbrCost/(1+rate[1]);
            Double originalFbrCost = importExcel.getDouble(row[i],15);
            Double fbrCost = originalFbrCost/(1+rate[1]);
            Double originalJxrCost = importExcel.getDouble(row[i],17);
            Double jxCost = originalJxrCost/(1+rate[2]);
            jkxlData.setOriginalTotalCost(importExcel.getDouble(row[i],12));
            jkxlData.setOriginalRgCost(originalRgCost);
            jkxlData.setRgCost(rgCost);
            jkxlData.setOriginalCbrCost(originalCbrCost);
            jkxlData.setCbrCost(cbrCost);
            jkxlData.setOriginalFbrCost(originalFbrCost);
            jkxlData.setFbrCost(fbrCost);
            jkxlData.setOriginalJxCost(originalJxrCost);
            jkxlData.setJxCost(jxCost);
            list.add(jkxlData);
        }
        return list;
    }
}
